<?php
    /*
    Plugin Name: Best Support Plugin
    Plugin URI: http://appsbd.com
    Description: It's a plugin for Best Support System App
    Version: 1.0.12
    Author: APPSBD
    Author URI: http://www.appsbd.com
    */
    define("BSSP_BASE","bssppb");
    define("BSSP_BASE_PATH",__FILE__);
    define("BSSP_BASE_VERSION","1.0");
    include_once "core/apbd_core_model.php";
    class ABPBSS_REMOTE_LOGIN extends apbd_core_model{
        
        protected function __construct()
        {
            parent::__construct();
            add_action( 'admin_post_nopriv_bssp_server_check', [$this,'valid_login'] );
        }
    
        function init(){
            //add_filter( 'login_redirect', [$this,'my_login_redirect'], 10, 3 );
            //add_action('wp_login',[$this,'loggedIn']);
            $this->check_response();
            register_setting(BSSP_BASE,BSSP_BASE, [$this,'ValidForm']);
            
        }
        public function  check_response()
        {
            $request_value= !empty($_GET['_bssrl'])?strtolower($_GET['_bssrl']):"";
            if($request_value=="login"){
                if(is_user_logged_in()){
                   $this->on_logged_in();
                   exit;
                }else{
                   wp_redirect(wp_login_url(get_site_url()."?_bssrl=login"));
                   exit;
                }
            }elseif($request_value=="check"){
               $this->valid_login();
            }
        }
        function on_logged_in($current_user=null,$isReturn=false){
                if (empty($current_user) && is_user_logged_in()) {
                    $current_user = wp_get_current_user();
                }
                if($current_user) {
                    $token = $this->generate_tocken($current_user);
                    //file_put_contents(dirname(BSSP_BASE_PATH)."/q.log","tokent:".$token,FILE_APPEND);
                    $bssrurl = $this->GetOptionValue("bssrurl");
                    if($isReturn){
                        return $bssrurl . "?token=" . $token;
                    }else {
                        //delete_option("_bssrl_is");
                        wp_redirect($bssrurl . "?token=" . $token);
                        exit;
                    }
                }
           
            //die("Worked");
        }
        function valid_login(){
            //array(“private_key”=>”Your defiend key”, “token”=> “received token”);
            file_put_contents(dirname(BSSP_BASE_PATH)."/q.log",print_r($_POST,true),FILE_APPEND);
            $private_key=!empty($_POST['private_key'])?$_POST['private_key']:"";
            $token=!empty($_POST['token'])?$_POST['token']:"";
            $response=new stdClass();
            $response->status=false;
            $response->data=null;
            if( $private_key == $this->GetOptionValue("private_key")) {
                $token_obj=$this->token_decode($token);
                if(!empty($token_obj->id)){
                    $user=get_user_by("ID",$token_obj->id);
                    if($user && $user instanceof WP_User) {
                        $userdata = new stdClass();
                        $userdata->first_name = $user->nickname;
                        $userdata->last_name = $user->last_name;
                        $userdata->email = $user->user_email;
                        $userdata->is_verified_email = "Y";
                        /*$userdata->gender = $user->ge;
                        $userdata->phone = "";
                        $userdata->address = "";
                        $userdata->city = "";
                        $userdata->zip = "";
                        $userdata->country ="";
                        $userdata->dob = "1988-25-02";*/
                        $userdata->photo_url =get_avatar_url( $user->ID );
                        $response->data=$userdata;
                    }
                }else{
                    //file_put_contents(dirname(BSSP_BASE_PATH)."/q.log","Empty token obj",FILE_APPEND);
                }
                $response->status = true;
            }else{
                //file_put_contents(dirname(BSSP_BASE_PATH)."/q.log","DOn't match private key",FILE_APPEND);
            }
            //file_put_contents(dirname(BSSP_BASE_PATH)."/q.log",print_r($response,true),FILE_APPEND);
            echo json_encode($response); die;
        }
        function generate_tocken($user){
            if(!empty($user->ID)) {
                if (function_exists("openssl_encrypt")) {
                    $token = new stdClass();
                    $token->id = $user->ID;
                    $token->time = time();
                    $token = base64_encode(serialize($token));
                    $password = $this->GetOptionValue("private_key");
                    $token= openssl_encrypt($token, "AES-128-ECB", $password);
                    return urlencode($token);
                }
            }
            return "";
        }
        function token_decode($token){
            if(function_exists("openssl_decrypt")) {
                $password = $this->GetOptionValue("private_key");
                $decrypted_string = openssl_decrypt($token, "AES-128-ECB", $password);
                if (!empty($decrypted_string)) {
                    return unserialize(base64_decode($decrypted_string));
                }
            }
            return null;
        }
        function AdminMenu()
        {
            add_menu_page("Best Support System", "Best Support System", 'activate_plugins', BSSP_BASE, array($this, 'OptionForm'), plugins_url("images/menu_icon.png", BSSP_BASE_PATH));
        
        }
        function ValidForm($input){
            if ( empty($_POST) || !wp_verify_nonce($_POST['bsspnonce'],BSSP_BASE) )
            {
                print 'Sorry, your nonce did not verify.';
                exit;
            }
           
            if(empty($_POST[BSSP_BASE]['private_key'])){
                self::AddError("Private Key can't be empty");
                return false;
            }if(empty($_POST[BSSP_BASE]['bssrurl'])){
                self::AddError("Support server redirect link (URL) can't be empty");
                return false;
            }
            $_POST[BSSP_BASE]['bssrurl']=str_replace([parse_url($_POST[BSSP_BASE]['bssrurl'],  PHP_URL_QUERY),'?'],"",$_POST[BSSP_BASE]['bssrurl']);
            if($_POST[BSSP_BASE]['private_key']==$this->option['private_key'] && ($_POST[BSSP_BASE]['bssrurl']==$this->option['bssrurl'])){
                self::AddError("No change for update");
                return true;
            }
          
            if(parent::ValidForm($input)){
                self::AddInfo("Save Successfully");
                return true;
            }else{
                self::AddError("Save failed");
                return false;
            }
        }
        function OptionForm(){
            ?>
            <div class="smPlugin">
                <div class="container-fluid">
                    <div class="main-panel panel panel-default">
                      <div class="panel-heading">
                          <div class="row">
                              <div class="col-xs-4 col-sm-2 col-md-1">
                                  <img class="main-logo img-responsive" src="<?php echo plugins_url ( "images/logo.png", BSSP_BASE_PATH ) ?>" alt="Main Logo">
                              </div>
                              <div class="col-xs-5 col-sm-8 col-md-9 title-text">
                              Best Support System Plugin
                                  <div class="sub-title">
                                      Top Featured PHP Application.
                                  </div>
                              </div>
                              <div class="col-xs-3 col-sm-2 col-md-2 text-right">
                                  <div class="text-version">
                                      Version : <?php echo BSSP_BASE_VERSION; ?>
                                  </div>
                              </div>
                              
                          </div>
                      </div>
                      <div class="panel-body">
                          <div class="row">
                          <div class="col-md-12">
                              <?php echo self::GetMsg();?>
                          </div>
                          </div>
                          <form id="<?php echo BSSP_BASE; ?>_form" method="post" action="options.php" enctype="multipart/form-data">
                              <?php  settings_errors(BSSP_BASE);
                                  settings_fields(BSSP_BASE);
                              
                                   wp_nonce_field(BSSP_BASE,"bsspnonce");?>
                              <div class="form-group">
                                  <label for="private_key">Private Key</label>
                                  <input id="private_key" type="text" class="form-control"  name="<?php echo $this->GetOptionName("private_key"); ?>" placeholder="Enter your private key" value="<?php echo $this->GetOptionValue("private_key"); ?>" required >
                                  <span class="help-block">
                                      Set the same private key in both site
                                  </span>
                              </div>
                              <div class="form-group">
                                  <label for="private_key">Login link (URL)</label>
                                  <div class="form-control">
                                      <?php echo wp_login_url()."?_bssrl=login";; ?>
                                  </div>
                                  <span class="help-block">
                                      Put this line into your support system <strong style="color:darkred;">Login URL</strong> input box
                                  </span>
                              </div>
                              <div class="form-group">
                                  <label for="private_key">Validation Link (URL)</label>
                                  <div id="validation_url" class="form-control">
                                      <?php echo admin_url( 'admin-post.php' )."?action=bssp_server_check";?>
                                  </div>
                                  <span class="help-block">
                                      Put this line into your support system <strong style="color:darkred;">Validation URL</strong> input box
                                  </span>
                              </div>
                              <div class="form-group">
                                  <label for="bssrurl">Support System Server Redirect Link (URL)</label>
                                  <input id="bssrurl" type="url" class="form-control"  name="<?php echo $this->GetOptionName("bssrurl"); ?>" placeholder="Enter your private key" value="<?php echo $this->GetOptionValue("bssrurl"); ?>" required >
                                  <span class="help-block"> Collect this link from your Support System<br>
                                      Example : http://192.168.10.71/Projects/support-system/user/remote-login/1.html
                                      <br/>Please do not add <strong style="color:darkred;"> ?token=&lt;token&gt;</strong>
                                  </span>
                              </div>
                             
                              <button type="submit" class="btn btn-success">Save</button>
                          </form>
                      </div>
                        <div class="panel-footer">
                            &copy; <?php echo date('Y') ?>, All right reserved by <a href="http://appsbd.com">appsbd.com</a>.
                        </div>
                    </div>

                </div> <!-- /container -->

            </div>
            <?php
        }
    }
   ABPBSS_REMOTE_LOGIN::start();
    
  