<?php
    /**
     * @since: 10/07/2018
     * @author: Sarwar Hasan
     * @version 1.0.0
     */
    class apbd_core_model{
        protected $option=[];
        private static $errorMessage=array();
        private static $errorFields=array();
        private static $infoMessage=array();
        protected static $selfobj;
        static function &start(){
            return static::get_instance();
        }
        static function &get_instance(){
            if(empty(static::$selfobj)){
                static::$selfobj=new static();
            }
            return static::$selfobj;
        }
        protected function __construct()
        {
            add_action('init', [$this,'init']);
            add_action('admin_menu', [$this,"AdminMenu"]);
            add_action( 'admin_enqueue_scripts', [$this,'enqueue_scripts'] );
            add_action( 'admin_print_styles', [$this,'enqueue_styles'] );
            $this->option=get_option(BSSP_BASE."_option",[]);
            
        }
   
        
        public static function AddError($msg,$isSession=false,$is_unique=false){
            add_settings_error(
                BSSP_BASE, // whatever you registered in `register_setting
                BSSP_BASE, // doesn't really mater
                $msg,
                'error' // error or notice works to make things pretty
            );
        }
        function GetOptionName($name){
            return BSSP_BASE."[$name]";
        }
        function GetOptionValue($name,$default=""){
            return isset($this->option[$name])?$this->option[$name]:$default;
        }
        public static function AddInfo($msg,$isSession=false,$is_unique=false){
            add_settings_error(
                BSSP_BASE, // whatever you registered in `register_setting
                BSSP_BASE, // doesn't really mater
                $msg,
                'updated' // error or notice works to make things pretty
            );
        }
        public static function GetError($prefix='',$postfix=''){
            $getSession=!empty($_SESSION["errorMessage"])?$_SESSION["errorMessage"]:null;
            if($getSession){
                self::$errorMessage=array_merge($getSession,self::$errorMessage);
            }
            if(count(self::$errorMessage)>0){
                return $prefix.implode($postfix.$prefix, self::$errorMessage).$postfix;
            }
            return '';
        }
        public static function GetInfo($prefix='',$postfix=''){
            $getSession=!empty($_SESSION["infoMessage"])?$_SESSION["infoMessage"]:null;
            if($getSession){
                self::$infoMessage=array_merge($getSession,self::$infoMessage);
            }
            if(count(self::$infoMessage)>0){
                return $prefix.implode($postfix.$prefix, self::$infoMessage).$postfix;
            }
            return '';
        }
        public static function GetMsg($prefix1='<div class="app-alert alert alert-success">',$prefix2='<div class="app-alert alert alert-danger">',$postfix='</div>'){
            $str=self::GetError($prefix2,$postfix);
            $str.=self::GetInfo($prefix1,$postfix);
            if(!empty($str)){
                return '<div class="d-m-b">'.$str.'</div>';
            }
            return '';
        }
        function enqueue_scripts() {
            wp_enqueue_script( array('jquery' ));
            wp_deregister_script ( "apboostrap3js" );
            wp_register_script (  "apboostrap3js", plugins_url ( "lib/bootstrap3/js/bootstrap.min.js", BSSP_BASE_PATH ) );
            wp_enqueue_script (  "apboostrap3js" );
        
            wp_deregister_script( "apbdbssmainjs" );
            wp_register_script ( "apbdbssmainjs", plugins_url ( "js/main.min.js", BSSP_BASE_PATH ) );
            wp_enqueue_script ( "apbdbssmainjs" );
        }
        function enqueue_styles() {
            wp_deregister_style( "apboostrap3css" );
            wp_register_style ( "apboostrap3css", plugins_url ( "lib/bootstrap3/css/bootstrapless.css", BSSP_BASE_PATH ) );
            wp_enqueue_style ( "apboostrap3css" );
        
            wp_deregister_style( "apbdbssmaincss" );
            wp_register_style ( "apbdbssmaincss", plugins_url ( "css/main.css", BSSP_BASE_PATH ) );
            wp_enqueue_style ( "apbdbssmaincss" );
        
        }
        function init(){
            register_setting(BSSP_BASE,BSSP_BASE, [$this,'ValidForm']);
        }
        function AdminMenu()
        {
            add_menu_page("Best Support System", "Best Support System", 'activate_plugins', BSSP_BASE, array($this, 'OptionForm'), plugins_url("images/menu_icon.png", BSSP_BASE_PATH));
        
        }
        function ValidForm($input){
            $this->option=$_POST[BSSP_BASE];
            $input=update_option(BSSP_BASE."_option",$this->option) OR add_option(BSSP_BASE."_option",$this->option);
            return $input;
        }
        function OptionForm(){
        
        }
    }